unit hiFlashEx;

interface

uses Kol,Share,Debug,Win,Windows,KOLFlash,Flash_TLB;

type
  THIFlashEx = class(THIWin)
   private
    FlashP:TKOLFlash;
   public
    _prop_FileName:string;
    _prop_Variable:string;
    _prop_x_pos:string;
    _prop_y_pos:string;
    _prop_BgColor:TColor;
    _prop_ScaleMode:byte;
    _prop_Quality:byte;
    _prop_AlignMode:byte;
    _prop_AllowScriptAccess:Integer;
    _prop_SetProperty:Integer;
    _prop_Menu:Integer;

    _data_FileName:THI_Event;
    _data_Variable:THI_Event;
    _data_x_pos:THI_Event;
    _data_y_pos:THI_Event;

    _event_onPlay:THI_Event;
    _event_onPause:THI_Event;
    _event_onStop:THI_Event;
    _event_onResize:THI_Event;
    
    procedure Init; override;
    procedure _work_doPlay(var _Data:TData; Index:word);
    procedure _work_doPause(var _Data:TData; Index:word);
    procedure _work_doStop(var _Data:TData; Index:word);
    procedure _work_doGoToFrame(var _Data:TData; Index:word);
    procedure _work_doBgColor(var _Data:TData; Index:word);
    procedure _work_doResize(var _Data:TData; Index:word);
    procedure _work_doSetVariable(var _Data:TData; Index:word);
    procedure _work_doScale(var _Data:TData; Index:word);
    procedure _work_doScaleMode(var _Data:TData; Index:word);
    procedure _work_doRotate(var _Data:TData; Index:word);
    procedure _work_doQuality(var _Data:TData; Index:word);
    procedure _work_doPosition(var _Data:TData; Index:word);
    procedure _work_doAlignMode(var _Data:TData; Index:word);
    procedure _var_CurrentFrame(var _Data:TData; Index:word);
    procedure _var_TotalFrames(var _Data:TData; Index:word);
    procedure _var_PercentLoaded(var _Data:TData; Index:word);
    procedure _var_FlashVersion(var _Data:TData; Index:word);
    
  end;

implementation

type TRGB = record r,g,b,x:byte; end;

Procedure THIFlashEx._work_doResize;
begin
inherited;
  _hi_CreateEvent(_Data,@_event_OnResize);
end;

Procedure THIFlashEx._work_doSetVariable;
begin
  FlashP.SetVariable (ReadString(_Data,_data_Variable,_prop_Variable), ToString(_Data));
end;

Procedure THIFlashEx._work_doScale;
begin
  FlashP.TSetProperty('/',2,ToString(_Data));
  FlashP.TSetProperty('/',3,ToString(_Data));
end;

Procedure THIFlashEx._work_doScaleMode;
begin
  FlashP.ScaleMode := (ToInteger(_Data));
end;

Procedure THIFlashEx._work_doQuality;
begin
  FlashP.Quality := (ToInteger(_Data));
end;

Procedure THIFlashEx._work_doAlignMode;
begin
  FlashP.AlignMode := (ToInteger(_Data));
end;

Procedure THIFlashEx.Init;
begin
  FlashP := NewKOLFlash(FParent);
  Control := FlashP;
  FlashP.ScaleMode := (_prop_ScaleMode);
  FlashP.Quality := (_prop_Quality);
  FlashP.AlignMode := (_prop_AlignMode);
  if _prop_Menu = 0 then FlashP.Menu := true
   else FlashP.Menu := false;
  if _prop_AllowScriptAccess = 0 then
   FlashP.AllowScriptAccess := ('never')
  else FlashP.AllowScriptAccess := ('always');
   FlashP.SetSize(_prop_Width,_prop_Height);
   FlashP.SetPosition(_prop_Left,_prop_Top);
  inherited;
  with TRGB(_prop_BgColor) do
   FlashP.BackgroundColor := RGB(b,g,r);
end;

Procedure THIFlashEx._work_doRotate;
begin
  FlashP.TSetProperty('/',10,ToString(_Data));
end;

procedure THIFlashEx._work_doBgColor;
begin
  with TRGB(ToInteger(_Data)) do
   FlashP.BackgroundColor := RGB(b,g,r);
end;

Procedure THIFlashEx._work_doPosition;
begin 
FlashP.TSetProperty('/',0,ReadString(_Data,_data_x_pos,_prop_x_pos));
FlashP.TSetProperty('/',1,ReadString(_Data,_data_y_pos,_prop_y_pos));
end;

procedure THIFlashEx._work_doPlay;
begin
  FlashP.LoadMovie(0,ReadFileName(ReadString(_Data,_data_FileName,_prop_FileName)));
  FlashP.Play;
  _hi_CreateEvent(_Data,@_event_onPlay);
end;

procedure THIFlashEx._work_doPause;
begin
  if FlashP.Playing then
    FlashP.Stop
   else FlashP.Play;
  _hi_CreateEvent(_Data,@_event_onPause);
end;

procedure THIFlashEx._work_doStop;
begin
  FlashP.Stop;
  FlashP.FrameNum := 0;
  _hi_CreateEvent(_Data,@_event_onStop);
end;

procedure THIFlashEx._work_doGoToFrame;
begin
  FlashP.FrameNum:=ReadInteger(_Data,null,0);
  FlashP.Play
end;

procedure THIFlashEx._var_CurrentFrame;
begin
  dtInteger(_Data,FlashP.FrameNum);
end;

procedure THIFlashEx._var_TotalFrames;
begin
  dtInteger(_Data,FlashP.TotalFrames);
end;

procedure THIFlashEx._var_PercentLoaded;
begin
  dtInteger(_Data,FlashP.PercentLoaded);
end;

procedure THIFlashEx._var_FlashVersion;
begin
  dtInteger(_Data,FlashP.FlashVersion);
end;

end.
